package AbsenceCurrent;

use FileHandle;
use Fcntl ':flock'; # import LOCK_* constants
use Carp;

use AbsenceConfig;
use AbsenceLog;

my $CURRENT_FILE	= AbsenceConfig::fetch('current_file');
my @CURRENT;
my $VERSION			= '1.0';

_read();

sub fetch
{
	@CURRENT;
}

#------------------------------------------------------------
# current month/day file routines
#------------------------------------------------------------
sub _read
{
	if (! -e $CURRENT_FILE) { return undef; }
	my $fh = FileHandle->new($CURRENT_FILE);
	defined($fh) || die "open on $CURRENT_FILE failed";

	my $line = <$fh>;
	chomp($line);
	$fh->close;

	@CURRENT = ($line =~ /^(\d+)\.(\d+)\.(\d+)$/);

	if (!@CURRENT) {
		abslog("cannot parse current [$line]");
	}
}

sub update
{
	@CURRENT = (localtime)[3,4,5];
	$CURRENT[1]++;
	$CURRENT[2] += 1900;

	my $openstr = (-e $CURRENT_FILE) ? "+<$CURRENT_FILE" : ">$CURRENT_FILE";
	my $fh = FileHandle->new($openstr);
	defined($fh) || confess "open on $CURRENT_FILE failed";

	flock($fh, LOCK_EX) || die "flock lock_ex on $CURRENT_FILE ($!)";
	print $fh join('.', @CURRENT),"\n";

	flock($fh, LOCK_UN) || die "flock lock_un on $CURRENT_FILE ($!)";
	$fh->close;
}

1;
